
#ifndef _BR_FIFO_H
#define _BR_FIFO_H

#ifdef __cplusplus
extern "C" {
#endif

#include "stdio.h"
#include "string.h"
#include "at32f402_405.h"

/* the max fifo number */
#define BR_MAX_FIFO       8

/* one fifo max size */
#define BR_MAX_FIFO_SIZE  (512+64)

typedef struct _br_fifo
{
  uint8_t is_empty;
  uint8_t is_full;
  
  uint32_t rd_pos;
  uint32_t wr_pos;
  
  uint32_t max_fifo;
  uint32_t max_size;
  uint32_t remain_size;
  
  uint32_t addr;
  uint32_t data_len[BR_MAX_FIFO];
  uint8_t data[BR_MAX_FIFO][BR_MAX_FIFO_SIZE];
}br_fifo_type;

void br_fifo_init(br_fifo_type *p_fifo);
uint32_t br_fifo_read(br_fifo_type *p_fifo, uint8_t *data, uint32_t length);
uint32_t br_fifo_write(br_fifo_type *p_fifo, uint8_t *data, uint32_t length);
uint32_t br_buffer_line_read(br_fifo_type *p_fifo, uint8_t *data, uint32_t len);
uint32_t br_buffer_line_write(br_fifo_type *p_fifo, uint8_t *data, uint32_t len);
uint8_t br_buffer_line_pop(br_fifo_type *p_fifo, uint8_t *data);
uint8_t br_buffer_line_push(br_fifo_type *p_fifo, uint8_t data);
uint8_t br_fifo_is_empty(br_fifo_type *p_fifo);
uint8_t br_fifo_is_full(br_fifo_type *p_fifo);

#ifdef __cplusplus
}
#endif

#endif
