
#ifndef _USB_BRIDGE_H
#define _USB_BRIDGE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "br_fifo.h"
#include "cdc_class.h"

typedef enum
{
  USB_TO_PERIPHERAL,
  PERIPHERAL_TO_USB
}trans_dir_enum;

typedef struct
{
  void (*init)(void *pdata);
  void (*deinit)(void *pdata);
  uint32_t (*br_tx)(uint8_t *data, uint32_t len);
  uint32_t(*fifo_write)(br_fifo_type *p_fifo, uint8_t *data, uint32_t length);
  uint32_t(*fifo_read)(br_fifo_type *p_fifo, uint8_t *data, uint32_t length);
  uint8_t (*br_tx_status)(void);
}br_handler;

typedef struct
{
  _usb_multi_bridge_enum br_type;
  br_handler *handler;
  
}usb_multi_bridge_type;

void usb_multi_bridge_init(void *pdata);
void usb_multi_bridge_set_type(_usb_multi_bridge_enum br_type);
uint8_t cdc_recv_callback(uint8_t *data, uint32_t length);
void usb_multi_bridge_process(usbd_core_type *pudev);
br_fifo_type *br_get_fifo(trans_dir_enum dir);
uint8_t usb_in_complete_callback(usbd_core_type *pudev);
_usb_multi_bridge_enum get_usb_to_type(void);

#ifdef __cplusplus
}
#endif

#endif
